#include <sys/types.h>
#include "global.h"
#include "mbuf.h"
#include "ax25.h"
#include "rpc.h"

/*
#include <stdio.h>
#include <sys/timeb.h>
*/

int32
rpcall(cmd,arg0,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11)
int cmd;
int32 arg0,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11;
{
    int32 arg[12];
    struct mbuf *bp;
    int i,size,lenidx;
    char *p;
/*  struct timeb tp1,tp2;
    FILE *fp; */

    arg[0] = arg0;
    arg[1] = arg1;
    arg[2] = arg2;
    arg[3] = arg3;
    arg[4] = arg4;
    arg[5] = arg5;
    arg[6] = arg6;
    arg[7] = arg7;
    arg[8] = arg8;
    arg[9] = arg9;
    arg[10] = arg10;
    arg[11] = arg11;
    /* find out the size of the mbuf we need */
    p = rpctab[cmd].fmt;
    size = lenidx = 0;
    while (*p) {
	if (*p == 'c')
	    ++size;
	if (*p == 'i')
	    size += sizeof(int);
	if (*p == '2')
	    size += sizeof(int16);
	if (*p == '4')
	    size += sizeof(int32);
	if (*p == 'p')
	    size += sizeof(p);
	if (*p == 'x') {
	    size += rpctab[cmd].len[lenidx];
	    ++lenidx;
	}
	++p;
    }
    if (lenidx)
	size += sizeof(int);
    bp = alloc_mbuf(size+sizeof(int));
    bp->cnt = size+sizeof(int);
    *(int *)bp->data = cmd;
    if (lenidx) { /* add an extra integer to keep track of NULL pointers */
	memset(bp->data + sizeof(int),0,sizeof(int));
	size = 2*sizeof(int);
	lenidx = 0;
    }
    else size = sizeof(int);
    /* now parse the rpc argument table */
    p = rpctab[cmd].fmt;
    for (i=0; *p; ++i, ++p) {
	if (*p == 'c') {
	    *(bp->data + size)  = (char) arg[i];
	    ++size;
	}
	if (*p == 'i') {
	    memcpy(bp->data + size,&arg[i],sizeof(int));
	    size += sizeof(int);
	}
	if (*p == '2') {
	    memcpy(bp->data + size,&arg[i],sizeof(int16));
	    size += sizeof(int16);
	}
	if (*p == '4') {
	    memcpy(bp->data + size,&arg[i],sizeof(int32));
	    size += sizeof(int32);
	}
	if (*p == 'p') {
	    memcpy(bp->data + size,&arg[i],sizeof(void *));
	    size += sizeof(p);
	}
	if (*p == 'x') {
	    if (arg[i]) {		/* arg is non-NULL */
		int tmp;
		memcpy(bp->data+size, (char *)arg[i], rpctab[cmd].len[lenidx]);
		memcpy(&tmp,bp->data+sizeof(int),sizeof(int));
		tmp |= (1 << lenidx);
		memcpy(bp->data+sizeof(int),&tmp,sizeof(int));
	    }
	    size += rpctab[cmd].len[lenidx];
	    ++lenidx;
	}
    }
    return rpcsend(bp,rpctab[cmd].noret);
/*  ftime(&tp1);
    i = rpcsend(bp,rpctab[cmd].noret);
    ftime(&tp2);
    fp=fopen("/tmp/logg","a");fprintf(fp,"cmd %d %d ms\n",cmd,(tp2.time - tp1.time)*1000 + (tp2.millitm - tp1.millitm));fclose(fp);
    return i;
*/
}
