#include "global.h"
#include "config.h"
#include "usock.h"

extern char *Socktypes[];
/* Socket status display command */
main(argc,argv)
int argc;
char *argv[];
{
	register struct usock *up;
	int s,i,i_state;

	shminit();
	i_state = dirps();
	if(argc < 2){
		printf("S# Type    PCB      Owner\n");
		for(s=0;s<Nusock;s++){
			up = &Usock[s];
			if(up->type == NOTUSED)
				continue;
			printf("%2d %-8s%-8lx ",
			       s,Socktypes[up->type],ptol(up->cb.p));
			for(i=0; i < sizeof(up->pid)/sizeof(int); ++i)
			    if(up->pid[i])
				printf("%ld ",up->pid[i]);
			printf("\n");
		}
		restore(i_state);
		iostop();
		return 0;
	}
	s = atoi(argv[1]);
	if(s < 0 || s >= Nusock){
		printf("Number out of range\n");
		restore(i_state);
		iostop();
		return 1;
	}
	up = &Usock[s];
	printf("%s %lx\n",Socktypes[up->type],ptol(up->cb.p));
	if(up->cb.p == NULL){
	    restore(i_state);
	    iostop();
	    return 0;
	}
/*
	switch(up->type){
	case TYPE_TCP:
		st_tcp(up->cb.tcb);
		break;
	case TYPE_UDP:
		st_udp(up->cb.udp,0);
		break;
#ifdef	AX25
	case TYPE_AX25I:
		st_ax25(up->cb.ax25);
		break;
#endif
#ifdef	NETROM
	case TYPE_NETROML4:
		donrdump(up->cb.nr4);
		break;
#endif
	}
*/
	restore(i_state);
	iostop();
	return 0;	
}

