union header {
	struct {
		union header *ptr;
		unsigned int size;
	} s;
	long l;
};

typedef union header HEADER;
#define	NULLHDR	(HEADER *)NULL

#define	ABLKSIZE	(sizeof (HEADER))

struct memory {
    struct memory *next;
    HEADER *base;
    HEADER **allocp;
    char *shmbase;
    char *heapbase;
    char *heaptop;
    unsigned long heapsize;
    int shmid;
    int semid;
    int block;
    struct mbuf **queue;
};

#define NULLMEM (struct memory *)0

/* This structure is inserted at the end of the memory segment */
struct mrec {
    HEADER base;
    HEADER *allocp;
    /* The server keeps the address of the main memory here, and the
       address of the user socket segment, the address of the RPC input
       queue, the address of the network Hopper, and the address of the
       select counter.
    */
    int32 data[5];
    int32 retval;		/* the return value of RPC calls. */
    int32 retval2;		/* Usually not used */
    unsigned long memfail;	/* Count of allocation failures */
    unsigned long allocs;	/* Total allocations */
    unsigned long frees;	/* Total frees */
    unsigned long garbage;	/* Total calls to free with garbage arg */
};
