/* This is how you send signals with a granularity of less than one second
 * on System V release 3...
 */
#include <stdio.h>
#include <signal.h>
#include <stropts.h>
#include <poll.h>
main (argc, argv)
int argc;
char *argv[];
{
    int parent,timeout;
    struct pollfd fds;
    if (argc != 2) {
	fprintf(stderr, "Usage: nostimer <MSPTICK>\n");
	exit(1);
    }
    parent = getppid();
    timeout = atoi(argv[1]);
    fds.fd = -1;
    while (1) {
	if (poll(&fds,1,timeout) == -1) {
	    perror("poll");
	    exit(1);
	}
	if (kill(parent,SIGALRM) == -1)
	    exit(0);			 /* parent exited? */
    }
}

	    
