#ifndef	NIT_MAX
/* Read fifo control structure */
struct fifo {
	char *buf;		/* Ring buffer */
	unsigned bufsize;	/* Size of ring buffer */
	char *wp;		/* Write pointer */
	char *rp;		/* Read pointer */
	unsigned short cnt;	/* count of characters in buffer */
};

/* Asynch controller control block */
struct asy {
	unsigned speed;		/* Line speed */
	char *tty;
	int IORser;		/* Input file descriptor */
	int IOWser;		/* Output file descriptor */
	struct iface *iface;
	struct fifo fifo;
	long rxchar;		/* Received characters */
	long txchar;		/* Transmitted characters */
	int pid;		/* PID of receiver process */
};
extern struct asy Asy[];
unsigned Nasy;		/* Actual number of asynch lines */
#define	ASY_MAX	5		/* Two asynch ports on the PC */

#define	SLIP_MODE	0
#define	AX25_MODE	1
#define	NRS_MODE	2

int asy_init(),asy_stop(),asy_ioctl();
int asy_stop(),asy_ioctl();
int doasystat();
unsigned asy_recv();

#ifdef PACKET
struct nitdrvr {
    char *buffer; 	/* Currently allocated rx buffer */
    struct iface *iface;
    int IOser;
};
extern struct nitdrvr Nitdrvr[];
extern int Nnit;
#endif /* PACKET */
#define NIT_MAX 3

#endif /* NIT_MAX */

